//
//  PlayingCardDeck.swift
//  PlayingCard
//
//  Created by Sameh Fakhouri on 10/2/19.
//  Copyright © 2019 Sameh Fakhouri. All rights reserved.
//

import Foundation

struct PlayingCardDeck {
    
    private(set) var cards = [PlayingCard]()
    
    mutating func draw() -> PlayingCard? {
        if cards.count > 0 {
            return cards.remove(at: cards.count.arc4random)
        } else {
            return nil
        }
    }
    

    init() {
        for suit in PlayingCard.Suit.all {
            for rank in PlayingCard.Rank.all {
                let playingCard = PlayingCard(suit: suit, rank: rank)
                cards.append(playingCard)
            }
        }
    }
    
    
}

extension Int {
    var arc4random: Int {
        if (self > 0) {
            return Int(arc4random_uniform(UInt32(self)))
        } else if (self < 0) {
            return -Int(arc4random_uniform(UInt32(-self)))
        } else {
            return 0
        }
    }
}
